From 0574759fc5c733c3b99014fa0aad429e17693d22 Mon Sep 17 00:00:00 2001
From: Stephen Gallagher <sgallagh@redhat.com>
Date: Jan 18 2018 16:36:31 +0000
Subject: [PATCH 4/48] Load and dump using libmodulemd


---

diff --git a/modulemd/__init__.py b/modulemd/__init__.py
index 21e8e01..b66fc24 100644
--- a/modulemd/__init__.py
+++ b/modulemd/__init__.py
@@ -71,9 +71,15 @@ def load_all(f):
 
     :param str f: File name to load
     """
-    with open(f, "r") as infile:
-        data = infile.read()
-    return loads_all(data)
+    l = list()
+    mmd_l = Modulemd.Module.new_all_from_file(f)
+
+    for mmd in mmd_l:
+        m = ModuleMetadata()
+        m.module = mmd
+        l.append(m)
+
+    return l
 
 def loads_all(s):
     """Loads multiple modulemd documents from a YAML multidocument
@@ -82,10 +88,13 @@ def loads_all(s):
     :param str s: String containing multiple YAML documents.
     """
     l = list()
-    for doc in yaml.safe_load_all(s):
+    mmd_l = Modulemd.Module.new_all_from_string(s)
+
+    for mmd in mmd_l:
         m = ModuleMetadata()
-        m.loadd(doc)
+        m.module = mmd
         l.append(m)
+
     return l
 
 def dump_all(f, l):
@@ -94,8 +103,11 @@ def dump_all(f, l):
     :param str f: Output filename
     :param list l: List of ModuleMetadata instances
     """
-    with open(f, "w") as outfile:
-        outfile.write(dumps_all(l))
+    mmds = list()
+    for module in l:
+        mmds.append(module.module)
+
+    return Modulemd.Module.dump_all(mmds, f)
 
 def dumps_all(l):
     """Dumps a list of ModuleMetadata instance into a YAML multidocument
@@ -103,7 +115,11 @@ def dumps_all(l):
 
     :param list l: List of ModuleMetadata instances
     """
-    return yaml.safe_dump_all([x.dumpd() for x in l], explicit_start=True)
+    mmds = list()
+    for module in l:
+        mmds.append(module.module)
+
+    return Modulemd.Module.dumps_all(mmds)
 
 class ModuleMetadata(object):
     """Class representing the whole module."""
@@ -207,8 +223,7 @@ class ModuleMetadata(object):
 
         :param str s: Raw metadata in YAML
         """
-        yamld = yaml.safe_load(s)
-        self.loadd(yamld)
+        self.module = Modulemd.Module.new_from_string(f)
 
     def loadd(self, d):
         """Loads metadata from a dictionary.
@@ -216,263 +231,29 @@ class ModuleMetadata(object):
         :param dict d: YAML metadata parsed into a dict
         :raises ValueError: If the metadata is invalid or unsupported.
         """
-        # header
-        if "document" not in d or d["document"] != "modulemd":
-            raise ValueError("The supplied data isn't a valid modulemd document")
-        if "version" not in d:
-            raise ValueError("Document version is required")
-        if d["version"] not in supported_mdversions:
-            raise ValueError("The supplied metadata version isn't supported")
-        self.mdversion = d["version"]
-        if "data" not in d or not isinstance(d["data"], dict):
-            raise ValueError("Data section missing or mangled")
-        # data
-        data = d["data"]
-        if "name" in data:
-            self.name = str(data["name"])
-        if "stream" in data:
-            self.stream = str(data["stream"])
-        if "version" in data:
-            self.version = int(data["version"])
-        if "context" in data:
-            self.context = str(data["context"])
-        if "arch" in data:
-            self.arch = str(data["arch"])
-        if "summary" in data:
-            self.summary = str(data["summary"])
-        if "description" in data:
-            self.description = str(data["description"])
-        if "eol" in data:
-            try:
-                self.eol = dateutil.parser.parse(str(data["eol"])).date()
-            except:
-                self.eol = None
-        if ("license" in data
-                and isinstance(data["license"], dict)
-                and "module" in data["license"]
-                and data["license"]["module"]):
-            self.module_licenses = set(data["license"]["module"])
-        if ("license" in data
-                and isinstance(data["license"], dict)
-                and "content" in data["license"]):
-            self.content_licenses = set(data["license"]["content"])
-        if ("dependencies" in data
-                and isinstance(data["dependencies"], dict)):
-            if ("buildrequires" in data["dependencies"]
-                    and isinstance(data["dependencies"]["buildrequires"], dict)):
-                for n, s in data["dependencies"]["buildrequires"].items():
-                    self.add_buildrequires(str(n), str(s))
-            if ("requires" in data["dependencies"]
-                    and isinstance(data["dependencies"]["requires"], dict)):
-                for n, s in data["dependencies"]["requires"].items():
-                    self.add_requires(str(n), str(s))
-        if "references" in data and data["references"]:
-            if "community" in data["references"]:
-                self.community = data["references"]["community"]
-            if "documentation" in data["references"]:
-                self.documentation = data["references"]["documentation"]
-            if "tracker" in data["references"]:
-                self.tracker = data["references"]["tracker"]
-        if "xmd" in data:
-            self.xmd = data["xmd"]
-        if ("profiles" in data
-                and isinstance(data["profiles"], dict)):
-            for profile in data["profiles"].keys():
-                self.profiles[profile] = ModuleProfile()
-                if "description" in data["profiles"][profile]:
-                    self.profiles[profile].description = \
-                        str(data["profiles"][profile]["description"])
-                if "rpms" in data["profiles"][profile]:
-                    self.profiles[profile].rpms = \
-                        set(data["profiles"][profile]["rpms"])
-        if ("api" in data
-                and isinstance(data["api"], dict)):
-            self.api = ModuleAPI()
-            if ("rpms" in data["api"]
-                    and isinstance(data["api"]["rpms"],list)):
-                self.api.rpms = set(data["api"]["rpms"])
-        if ("filter" in data
-                and isinstance(data["filter"], dict)):
-            self.filter = ModuleFilter()
-            if ("rpms" in data["filter"]
-                    and isinstance(data["filter"]["rpms"],list)):
-                self.filter.rpms = set(data["filter"]["rpms"])
-        if ("buildopts" in data
-                and isinstance(data["buildopts"], dict)):
-            self.buildopts = ModuleBuildopts()
-            if ("rpms" in data["buildopts"]
-                    and isinstance(data["buildopts"]["rpms"], dict)):
-                self.buildopts.rpms = ModuleBuildoptsRPMs()
-                if ("macros" in data["buildopts"]["rpms"]
-                        and isinstance(data["buildopts"]["rpms"]["macros"], str)):
-                    self.buildopts.rpms.macros = data["buildopts"]["rpms"]["macros"]
-        if ("components" in data
-                and isinstance(data["components"], dict)):
-            self.components = ModuleComponents()
-            if "rpms" in data["components"]:
-                for p, e in data["components"]["rpms"].items():
-                    extras = dict()
-                    extras["rationale"] = e["rationale"]
-                    if "buildorder" in e:
-                        extras["buildorder"] = int(e["buildorder"])
-                    if "repository" in e:
-                        extras["repository"] = str(e["repository"])
-                    if "cache" in e:
-                        extras["cache"] = str(e["cache"])
-                    if "ref" in e:
-                        extras["ref"] = str(e["ref"])
-                    if ("arches" in e
-                            and isinstance(e["arches"], list)):
-                        extras["arches"] = set(str(x) for x in e["arches"])
-                    if ("multilib" in e
-                            and isinstance(e["multilib"], list)):
-                        extras["multilib"] = set(str(x) for x in e["multilib"])
-                    self.components.add_rpm(p, **extras)
-            if "modules" in data["components"]:
-                for p, e in data["components"]["modules"].items():
-                    extras = dict()
-                    extras["rationale"] = e["rationale"]
-                    if "buildorder" in e:
-                        extras["buildorder"] = int(e["buildorder"])
-                    if "repository" in e:
-                        extras["repository"] = str(e["repository"])
-                    if "ref" in e:
-                        extras["ref"] = str(e["ref"])
-                    self.components.add_module(p, **extras)
-        if ("artifacts" in data
-                and isinstance(data["artifacts"], dict)):
-            self.artifacts = ModuleArtifacts()
-            if ("rpms" in data["artifacts"]
-                    and isinstance(data["artifacts"]["rpms"],list)):
-                self.artifacts.rpms = set(data["artifacts"]["rpms"])
+        self.loads(yaml.dump(d))
+
 
     def dump(self, f):
         """Dumps the metadata into the supplied file.
 
         :param str f: File name of the destination
         """
-        data = self.dumps()
-        with open(f, "w") as outfile:
-            outfile.write(data)
+        self.module.dump(f)
 
     def dumpd(self):
         """Dumps the metadata into a dictionary.
 
         :rtype: dict
         """
-        doc = dict()
-        # header
-        doc["document"] = "modulemd"
-        doc["version"] = self.mdversion
-        # data
-        d = dict()
-        if self.name:
-            d["name"] = self.name
-        if self.stream:
-            d["stream"] = self.stream
-        if self.version:
-            d["version"] = self.version
-        if self.context:
-            d["context"] = self.context
-        if self.arch:
-            d["arch"] = self.arch
-        d["summary"] = self.summary
-        d["description"] = self.description
-        if self.eol:
-            d["eol"] = str(self.eol)
-        d["license"] = dict()
-        d["license"]["module"] = sorted(list(self.module_licenses))
-        if self.content_licenses:
-            d["license"]["content"] = sorted(list(self.content_licenses))
-        if self.buildrequires or self.requires:
-            d["dependencies"] = dict()
-            if self.buildrequires:
-                d["dependencies"]["buildrequires"] = self.buildrequires
-            if self.requires:
-                d["dependencies"]["requires"] = self.requires
-        if self.community or self.documentation or self.tracker:
-            d["references"] = dict()
-            if self.community:
-                d["references"]["community"] = self.community
-            if self.documentation:
-                d["references"]["documentation"] = self.documentation
-            if self.tracker:
-                d["references"]["tracker"] = self.tracker
-        if self.xmd:
-            d["xmd"] = self.xmd
-        if self.profiles:
-            d["profiles"] = dict()
-            for profile in self.profiles.keys():
-                if self.profiles[profile].description:
-                    if profile not in d["profiles"]:
-                        d["profiles"][profile] = dict()
-                    d["profiles"][profile]["description"] = \
-                        str(self.profiles[profile].description)
-                if self.profiles[profile].rpms:
-                    if profile not in d["profiles"]:
-                        d["profiles"][profile] = dict()
-                    d["profiles"][profile]["rpms"] = \
-                        sorted(list(self.profiles[profile].rpms))
-        if self.api:
-            d["api"] = dict()
-            if self.api.rpms:
-                d["api"]["rpms"] = sorted(list(self.api.rpms))
-        if self.filter:
-            d["filter"] = dict()
-            if self.filter.rpms:
-                d["filter"]["rpms"] = sorted(list(self.filter.rpms))
-        if self.buildopts:
-            d["buildopts"] = dict()
-            if self.buildopts.rpms:
-                d["buildopts"]["rpms"] = dict()
-                if self.buildopts.rpms.macros:
-                    d["buildopts"]["rpms"]["macros"] = \
-                            self.buildopts.rpms.macros
-        if self.components:
-            d["components"] = dict()
-            if self.components.rpms:
-                d["components"]["rpms"] = dict()
-                for p in self.components.rpms.values():
-                    extra = dict()
-                    extra["rationale"] = p.rationale
-                    if p.buildorder:
-                        extra["buildorder"] = p.buildorder
-                    if p.repository:
-                        extra["repository"] = p.repository
-                    if p.ref:
-                        extra["ref"] = p.ref
-                    if p.cache:
-                        extra["cache"] = p.cache
-                    if p.arches:
-                        extra["arches"] = sorted(list(p.arches))
-                    if p.multilib:
-                        extra["multilib"] = sorted(list(p.multilib))
-                    d["components"]["rpms"][p.name] = extra
-            if self.components.modules:
-                d["components"]["modules"] = dict()
-                for p in self.components.modules.values():
-                    extra = dict()
-                    extra["rationale"] = p.rationale
-                    if p.buildorder:
-                        extra["buildorder"] = p.buildorder
-                    if p.repository:
-                        extra["repository"] = p.repository
-                    if p.ref:
-                        extra["ref"] = p.ref
-                    d["components"]["modules"][p.name] = extra
-        if self.artifacts:
-            d["artifacts"] = dict()
-            if self.artifacts.rpms:
-                d["artifacts"]["rpms"] = sorted(list(self.artifacts.rpms))
-        doc["data"] = d
-        return doc
+        return yaml.safe_load(self.dumps())
 
     def dumps(self):
         """Dumps the metadata into a string.
 
         :rtype: str
         """
-        return yaml.safe_dump(self.dumpd(), default_flow_style=False)
+        return self.module.dumps()
 
     @property
     def mdversion(self):

